#include "stdafx.h"
#include "geometry.h"
#include "MYD3D9Utils.h"

	const int CountVertex=52;
	const int StartRoom=36;
	const int StartMirror=72;
	const int CountFiguresIndex=36;
	const int CountRoomIndex=36;
	const int CountMirrorIndex=6;
	const int CountIndex=CountFiguresIndex+CountRoomIndex+CountMirrorIndex;
	const int ROOM_SIZE=30;
	const int MIRROR_SIZE=10;

const D3DXCOLOR     WHITE(D3DCOLOR_XRGB(255, 255, 255));
const D3DXCOLOR     BLACK(D3DCOLOR_XRGB(  0,   0,   0));
const D3DXCOLOR       RED(D3DCOLOR_XRGB(255,   0,   0));
const D3DXCOLOR     GREEN(D3DCOLOR_XRGB(  0, 255,   0));
const D3DXCOLOR      BLUE(D3DCOLOR_XRGB(  0,   0, 255));
const D3DXCOLOR    YELLOW(D3DCOLOR_XRGB(255, 255,   0));
const D3DXCOLOR      CYAN(D3DCOLOR_XRGB(  0, 255, 255));
const D3DXCOLOR   MAGENTA(D3DCOLOR_XRGB(255,   0, 255));
const D3DXCOLOR   SHADOW(0.0f,1.0f,0.0f,0.5f);
const D3DXCOLOR    MIRROR(0.0f,1.0f,1.0f,0.5f);
const D3DXCOLOR		SPHERE(0.0f,0.2f,0.0f,1.0f);
const D3DMATERIAL9 BLUE_MTRL = InitMaterial(BLUE, BLUE, WHITE, BLACK, 50.0f);
const D3DMATERIAL9 WHITE_MTRL = InitMaterial(WHITE, WHITE, WHITE, BLACK, 50.0f);
const D3DMATERIAL9 GREEN_MTRL = InitMaterial(GREEN, GREEN, WHITE, BLACK, 50.0f);
const D3DMATERIAL9 SPHERE_MTRL = InitMaterial(SPHERE,SPHERE,SPHERE,BLACK,60.0f);
const D3DMATERIAL9 BLACK_MTRL = InitMaterial(BLACK, BLACK, BLACK, BLACK, 0.0f);
const D3DMATERIAL9 SHADOW_MTRL = InitMaterial(BLACK, SHADOW, BLACK,BLACK, 0.0f);
const D3DMATERIAL9 MIRROR_MTRL = InitMaterial(MIRROR,MIRROR,MIRROR,BLACK,50.0f);
const D3DXVECTOR3 LightPos=D3DXVECTOR3(0.0f,float(20.0f)-5.0f,0.0f);
struct CUSTOMVERTEX
{
   float x,y,z;
   float nx,ny,nz;
   float tu,tv;// 
};

// Our custom FVF, which describes our custom vertex structure
#define D3DFVF_CUSTOMVERTEX (D3DFVF_XYZ | D3DFVF_NORMAL |D3DFVF_TEX1)



CGeometry::CGeometry()
{
	g_pVB=NULL;
	g_pIB=NULL;

	mesh=NULL;
	BoxMesh=NULL;
	TextureFileName=new TCHAR[40];
	lstrcpy(TextureFileName,L"Tex7.ppm");

}


HRESULT CGeometry::Init(LPDIRECT3DDEVICE9 pd3dDevice)
{


	HRESULT hr;
	// .   
	float x1=0.166666666;//66666666666666666666667f;
	float x2=0.8333333333;//3333333333333333333333f;

	CUSTOMVERTEX Vertices[CountVertex] =
    {
		//
		-2.0f,3.0f,-2.0f, 0.0f,1.0f,-6.0f,  x1,0.0f,
		2.0f,3.0f,-2.0f,0.0f,1.0f,-6.0f,    x2,0.0f,
		3.0f,-3.0f,-3.0f,0.0f,1.0f,-6.0f,  1.0f,1.0f,

       -3.0f,-3.0f,-3.0f, 	0.0f,1.0f,-6.0f,  0.0f,1.0f,
		
	   
	   //
	2.0f,3.0f,2.0f,0.0f,1.0f,6.0f,x1,0.0f,
		-2.0f,3.0f,2.0f,0.0f,1.0f,6.0f,x2,0.0f,
		-3.0f,-3.0f,3.0f,0.0f,1.0f,6.0f,	1.0f,1.0f,
		3.0f,-3.0f,3.0f,0.0f,1.0f,6.0f,0.0f,1.0f,
		//
	
		
			-2.0f,3.0f,-2.0f,	0.0f,1.0f,0.0f,		0.0f,0.0f,
			-2.0f,3.0f,2.0f,0.0f,1.0f,0.0f,1.0f,0.0f,			
			2.0f,3.0f,2.0f,0.0f,1.0f,0.0f,1.0f,1.0f,
			2.0f,3.0f,-2.0f,0.0f,1.0f,0.0f,	0.0f,1.0f,
//
			-3.0f,-3.0f,-3.0f,0.0f,-1.0f,0.0f,0.0f,0.0f,
			3.0f,-3.0f,-3.0f,0.0f,-1.0f,0.0f,1.0f,0.0f,
			3.0f,-3.0f,3.0f,0.0f,-1.0f,0.0f,	1.0f,1.0f,
			-3.0f,-3.0f,3.0f,	0.0f,-1.0f,0.0f,	0.0f,1.0f,
//////////////////////////////////
//
		2.0f,3.0f,-2.0f,	6.0f,1.0f,0.0f,	x1,0.0f,
		2.0f,3.0f,2.0f,6.0f,1.0f,0.0f,x2,0.0f,	
		3.0f,-3.0f,3.0f,6.0f,1.0f,0.0f,	1.0f,1.0f,
		3.0f,-3.0f,-3.0f,6.0f,1.0f,0.0f, 0.0f,1.0f,
//
		-2.0f,3.0f,2.0f,-6.0f,1.0f,0.0f,	x1,0.0f,
		-2.0f,3.0f,-2.0f,-6.0f,1.0f,0.0f,	x2,0.0f,
		-3.0f,-3.0f,-3.0f,-6.0f,1.0f,0.0f,	1.0f,1.0f,
		-3.0f,-3.0f,3.0f,-6.0f,1.0f,0.0f,0.0f,1.0f,

		//
		-ROOM_SIZE,ROOM_SIZE,MIRROR_SIZE,1.0f,0.0f,0.0f,0.0f,0.0f,
		-ROOM_SIZE,ROOM_SIZE,ROOM_SIZE,1.0f,0.0f,0.0f,1.0f,0.0f,
		-ROOM_SIZE,-ROOM_SIZE,ROOM_SIZE,1.0f,0.0f,0.0f,1.0f,1.0f,
		-ROOM_SIZE,-ROOM_SIZE,MIRROR_SIZE,1.0f,0.0f,0.0f,0.0f,1.0f,
	

		//
		-ROOM_SIZE,ROOM_SIZE,-ROOM_SIZE,1.0f,0.0f,0.0f,0.0f,0.0f,
		-ROOM_SIZE,ROOM_SIZE,-MIRROR_SIZE,1.0f,0.0f,0.0f,1.0f,0.0f,
		-ROOM_SIZE,-ROOM_SIZE,-MIRROR_SIZE,1.0f,0.0f,0.0f,1.0f,1.0f,
		-ROOM_SIZE,-ROOM_SIZE,-ROOM_SIZE,1.0f,0.0f,0.0f,0.0f,1.0f,
	
		//
		-ROOM_SIZE,-ROOM_SIZE,ROOM_SIZE,0.0f,1.0f,0.0f,0.0f,0.0f,
		ROOM_SIZE,-ROOM_SIZE,ROOM_SIZE,0.0f,1.0f,0.0f,1.0f,0.0f,
		ROOM_SIZE,-ROOM_SIZE,-ROOM_SIZE,0.0f,1.0f,0.0f,1.0f,1.0f,
		-ROOM_SIZE,-ROOM_SIZE,-ROOM_SIZE,0.0f,1.0f,0.0f,0.0f,1.0f,

		//
		-ROOM_SIZE,ROOM_SIZE,-ROOM_SIZE,0.0f,-1.0f,0.0f,0.0f,0.0f,
		ROOM_SIZE,ROOM_SIZE,-ROOM_SIZE,0.0f,-1.0f,0.0f,1.0f,0.0f,
		ROOM_SIZE,ROOM_SIZE,ROOM_SIZE,0.0f,-1.0f,0.0f,1.0f,1.0f,
		-ROOM_SIZE,ROOM_SIZE,ROOM_SIZE,0.0f,-1.0f,0.0f,0.0f,1.0f,
		// 
		-ROOM_SIZE,ROOM_SIZE,ROOM_SIZE,0.0f,0.0f,-1.0f,0.0f,0.0f,
		ROOM_SIZE,ROOM_SIZE,ROOM_SIZE,0.0f,0.0f,-1.0f,1.0f,0.0f,
		ROOM_SIZE,-ROOM_SIZE,ROOM_SIZE,0.0f,0.0f,-1.0f,1.0f,1.0f,
		-ROOM_SIZE,-ROOM_SIZE,ROOM_SIZE,0.0f,0.0f,-1.0f,0.0f,1.0f,

		// 
		ROOM_SIZE,ROOM_SIZE,ROOM_SIZE,-1.0f,0.0f,0.0f,0.0f,0.0f,
		ROOM_SIZE,ROOM_SIZE,-ROOM_SIZE,-1.0f,0.0f,0.0f,1.0f,0.0f,
		ROOM_SIZE,-ROOM_SIZE,-ROOM_SIZE,-1.0f,0.0f,0.0f,1.0f,1.0f,
		ROOM_SIZE,-ROOM_SIZE,ROOM_SIZE,-1.0f,0.0f,0.0f,0.0f,1.0f,

		//
		-ROOM_SIZE,ROOM_SIZE,-MIRROR_SIZE,1.0f,0.0f,0.0f,0.0f,0.0f,
		-ROOM_SIZE,ROOM_SIZE,MIRROR_SIZE,1.0f,0.0f,0.0f,1.0f,0.0f,
		-ROOM_SIZE,-ROOM_SIZE,MIRROR_SIZE,1.0f,0.0f,0.0f,1.0f,1.0f,
		-ROOM_SIZE,-ROOM_SIZE,-MIRROR_SIZE,1.0f,0.0f,0.0f,0.0f,1.0f,
    };
	if( FAILED( pd3dDevice->CreateVertexBuffer( CountVertex*sizeof(CUSTOMVERTEX),
                                                  0, D3DFVF_CUSTOMVERTEX,
                                                  D3DPOOL_DEFAULT, &g_pVB, NULL ) ) )
    {
        return E_FAIL;
    }

    // Now we fill the vertex buffer. To do this, we need to Lock() the VB to
    // gain access to the Vertices. This mechanism is required becuase vertex
    // buffers may be in device memory.
    VOID* pVertices;
    if( FAILED( g_pVB->Lock( 0, sizeof(Vertices), (void**)&pVertices, 0 ) ) )
        return E_FAIL;
    memcpy( pVertices, Vertices, sizeof(Vertices) );
    g_pVB->Unlock();


	WORD Indexes[CountIndex] = 
	{
		//
		0,1,2,
		0,2,3,
		//
		4,5,6,
		4,6,7,
		//
		8,9,10,
		8,10,11,
		//
		12,13,14,
		12,14,15,
		//
		16,17,18,
		16,18,19,
		//
		20,21,22,
		20,22,23,
		

		//
		24,25,26,
		24,26,27,

		28,29,30,
		28,30,31,

		32,33,34,
		32,34,35,

		//
		36,37,38,
		36,38,39,

		// 
		40,41,42,
		40,42,43,

		// 
		44,45,46,
		44,46,47,

		//

		48,49,50,
		48,50,51,
	};


	if( FAILED( pd3dDevice->CreateIndexBuffer( CountIndex * sizeof(WORD),
               0,
               D3DFMT_INDEX16,
               D3DPOOL_MANAGED,
               &g_pIB,
               0) ))
    {
        return E_FAIL;
    }

    // Now we fill the vertex buffer. To do this, we need to Lock() the VB to
    // gain access to the Vertices. This mechanism is required becuase vertex
    // buffers may be in device memory.
    VOID* pIndexes;
    if( FAILED( g_pIB->Lock( 0, sizeof(Indexes), (void**)&pIndexes, 0 ) ) )
        return E_FAIL;
    memcpy( pIndexes, Indexes, sizeof(Indexes) );
    g_pVB->Unlock();
	D3DXCreateSphere(pd3dDevice,1.0f,20,20,&mesh,NULL);
	D3DXCreateBox(pd3dDevice,1.0f,1.0f,1.0f,&BoxMesh,NULL);


	V_RETURN(D3DXCreateTextureFromFile(pd3dDevice,TextureFileName,&Tex));
		;


	return S_OK;
}


void CGeometry::Draw(LPDIRECT3DDEVICE9 pd3dDevice)
{

	DrawReflection(pd3dDevice);
	DrawObjects(pd3dDevice);
	DrawShadow(pd3dDevice);
	
	
	//DrawObjects(pd3dDevice);
}

D3DXMATRIXA16 CGeometry::SetTetraMatrix()
{
	static unsigned DIVIDER=int(2*D3DX_PI*1000.0f);
	float angle=float(timeGetTime()%DIVIDER)/1000;
	D3DXMATRIXA16 matWorld;
	D3DXMATRIXA16 matTemp;
	D3DXMatrixIdentity( &matWorld );
    D3DXMatrixTranslation( &matTemp, 0, 0, 0 );
	D3DXMatrixMultiply(&matWorld,  &matTemp, &matWorld);
	D3DXMatrixRotationY(&matTemp, angle);
	D3DXMatrixMultiply(&matWorld, &matTemp, &matWorld);
	D3DXMatrixTranslation(&matTemp, 3, 2, 0);
	D3DXMatrixMultiply(&matWorld, &matTemp, &matWorld);
	D3DXMatrixRotationX(&matTemp, angle);
	D3DXMatrixMultiply(&matWorld, &matTemp, &matWorld);
	return matWorld;
}

D3DXMATRIXA16 CGeometry::SetTeapotMatrix()
{
	float angle=0.0f;
	D3DXMATRIXA16 matWorld;
	D3DXMATRIXA16 matTemp;
	D3DXMatrixIdentity( &matWorld );
	D3DXMatrixTranslation( &matTemp, -9, 0, 0 );
	D3DXMatrixMultiply(&matWorld,  &matTemp, &matWorld);
		
	D3DXMatrixRotationX(&matTemp,angle + D3DX_PI);
	D3DXMatrixMultiply(&matWorld, &matTemp, &matWorld);
	
	D3DXMatrixTranslation(&matTemp, 2, 0, 0);
	D3DXMatrixMultiply(&matWorld, &matTemp, &matWorld);
	D3DXMatrixRotationY(&matTemp, angle + D3DX_PI/3);
	D3DXMatrixMultiply(&matWorld, &matTemp, &matWorld);
	
	return matWorld;
}


void CGeometry::Release()
{
	SAFE_RELEASE(mesh);
	SAFE_RELEASE(g_pVB);
	SAFE_RELEASE(g_pIB);
	SAFE_RELEASE(BoxMesh);
	SAFE_RELEASE(Tex);

}

HRESULT CGeometry::SetupLights(LPDIRECT3DDEVICE9 pd3dDevice)
{
	D3DLIGHT9 light0=InitPointLight(D3DXCOLOR(0xffffffff),LightPos);
	static D3DXVECTOR3 lp(LightPos.x-2*ROOM_SIZE,LightPos.y,LightPos.z);
	D3DLIGHT9 light1=InitPointLight(D3DXCOLOR(0xffffffff),lp);
	pd3dDevice->SetRenderState(D3DRS_AMBIENT,0x00505050);
	pd3dDevice->SetLight(0,&light0);
	pd3dDevice->LightEnable(0,TRUE);
	pd3dDevice->SetLight(1,&light1);
	pd3dDevice->LightEnable(1,TRUE);


	return S_OK;
}

void CGeometry::DrawRoom(LPDIRECT3DDEVICE9 pd3dDevice)
{
	
}


void CGeometry::DrawObjects(LPDIRECT3DDEVICE9 pd3dDevice,UINT Mode)
{
	D3DXMATRIXA16 matTetrahedron;
	D3DXMATRIXA16 matTeapot;
	D3DXMATRIXA16 mWorld,mRes,S,mShadowRes,mInv,mTrans;
	
	pd3dDevice->GetTransform(D3DTS_WORLD,&mWorld);
	if ((Mode==DO_SHADOW)|| (Mode==DO_MIRRORSHADOW))
	{
		pd3dDevice->SetMaterial(&SHADOW_MTRL);
		pd3dDevice->SetTexture(0,NULL);

	}
	else
	{
		pd3dDevice->SetTexture(0,Tex);
	}

	matTetrahedron = SetTetraMatrix();
	

	const float SM=0.1f;
	static D3DXVECTOR4 v1(-ROOM_SIZE,-ROOM_SIZE+SM,ROOM_SIZE,0.0f);
	static D3DXVECTOR4 v2(ROOM_SIZE,-ROOM_SIZE+SM,ROOM_SIZE,0.0f);
	static D3DXVECTOR4 v3(ROOM_SIZE,-ROOM_SIZE+SM,-ROOM_SIZE,0.0f);
	static D3DXVECTOR4 lp(LightPos.x,LightPos.y,LightPos.z,1.0f);
	static D3DXVECTOR4 lp2(LightPos.x-2*ROOM_SIZE,LightPos.y,LightPos.z,1.0f);

	
	D3DXMATRIXA16 W, T, R;
	static	D3DXVECTOR4 mv1(-ROOM_SIZE,ROOM_SIZE,-MIRROR_SIZE,0.0f);
	static	D3DXVECTOR4 mv2(-ROOM_SIZE,ROOM_SIZE,MIRROR_SIZE,0.0f);
	static	D3DXVECTOR4 mv3(-ROOM_SIZE,-ROOM_SIZE,MIRROR_SIZE,0.0f);

	switch (Mode)
	{
	case DO_SHADOW:
	
		CreateShadowMatrix(pd3dDevice,&S,lp,v1,v2,v3);
		mRes=mWorld*matTetrahedron*S;
		break;
	case DO_NORMAL:
		mRes=mWorld*matTetrahedron;
		pd3dDevice->SetTexture(0,Tex);
		pd3dDevice->SetMaterial(&WHITE_MTRL);
		break;
	case DO_MIRROR:	
		//  
	
		CreateReflectionMatrix(pd3dDevice,&R,mv1,mv2,mv3);
		mRes = mWorld*matTetrahedron*R;
		break;
	case DO_MIRRORSHADOW:
	
		CreateShadowMatrix(pd3dDevice,&S,lp2,v1,v2,v3);
		CreateReflectionMatrix(pd3dDevice,&R,mv1,mv2,mv3);
		mRes=mWorld*matTetrahedron*R*S;
		break;
	}
	pd3dDevice->SetTransform( D3DTS_WORLD, &mRes);
	pd3dDevice->SetStreamSource( 0, g_pVB, 0, sizeof(CUSTOMVERTEX) );
	pd3dDevice->SetFVF( D3DFVF_CUSTOMVERTEX );
	pd3dDevice->SetIndices(g_pIB);
	pd3dDevice->DrawIndexedPrimitive(D3DPT_TRIANGLELIST , 0, 0, CountVertex, 0, CountFiguresIndex/3 );


	switch (Mode)
	{
	case DO_MIRROR:
		mRes = mWorld*R;
		break;
	default:
		mRes=mWorld;
	}
	if ((Mode==DO_NORMAL)||(Mode==DO_MIRROR))
	{
		pd3dDevice->SetTransform(D3DTS_WORLD,&mRes);
		pd3dDevice->DrawIndexedPrimitive(D3DPT_TRIANGLELIST , 0, 0, CountVertex, StartRoom, CountRoomIndex/3 );
	}


	matTeapot = SetTeapotMatrix();
	

	switch (Mode)
	{
	case DO_NORMAL:
		mRes=mWorld*matTeapot;
		break;
	case DO_SHADOW:
		mRes=mWorld*matTeapot*S;
		break;
	case DO_MIRROR:
		mRes = mWorld*matTeapot*R;
		break;
	case DO_MIRRORSHADOW:
		mRes=mWorld*matTeapot*R*S;
		break;
	}
	pd3dDevice->SetTransform( D3DTS_WORLD, &mRes);
	if ((Mode==DO_NORMAL)|| (Mode==DO_MIRROR))
		pd3dDevice->SetMaterial(&SPHERE_MTRL);
	pd3dDevice->SetTexture(0,NULL);
	mesh->DrawSubset(0);

if (Mode!=DO_MIRRORSHADOW)
{
	DrawRoom(pd3dDevice);
	pd3dDevice->SetTexture(0,NULL);

	
	D3DXMatrixTranslation(&mTrans,LightPos.x,LightPos.y,LightPos.z);
	
	switch (Mode)
	{
	case DO_NORMAL:
		mRes=mWorld*mTrans;
		break;
	case DO_MIRROR:
		mRes=mWorld*mTrans*R;
		break;
	}

	if ((Mode==DO_NORMAL)||(Mode==DO_MIRROR))
	{
		pd3dDevice->SetTransform(D3DTS_WORLD,&mRes);
		pd3dDevice->SetRenderState(D3DRS_LIGHTING,FALSE);
		pd3dDevice->SetMaterial (&WHITE_MTRL);
		mesh->DrawSubset(0);
		pd3dDevice->SetRenderState(D3DRS_LIGHTING,TRUE);
		
	}
}
	pd3dDevice->SetTransform(D3DTS_WORLD,&mWorld);

}

void CGeometry::DrawShadow(LPDIRECT3DDEVICE9 pd3dDevice,UINT Mode)
{
	
	D3DXMATRIX S,mWorld,mRes,mTrans;
	
	pd3dDevice->GetTransform(D3DTS_WORLD,&mWorld);

	if (Mode==DO_SHADOW)
	{

		pd3dDevice->SetRenderState(D3DRS_STENCILENABLE,    true);
		pd3dDevice->SetRenderState(D3DRS_STENCILFUNC,      D3DCMP_EQUAL);
		pd3dDevice->SetRenderState(D3DRS_STENCILREF,       0x0);
		pd3dDevice->SetRenderState(D3DRS_STENCILMASK,      0xffffffff);
		pd3dDevice->SetRenderState(D3DRS_STENCILWRITEMASK, 0xffffffff);
		pd3dDevice->SetRenderState(D3DRS_STENCILZFAIL,     D3DSTENCILOP_KEEP);
		pd3dDevice->SetRenderState(D3DRS_STENCILFAIL,      D3DSTENCILOP_KEEP);
		pd3dDevice->SetRenderState(D3DRS_STENCILPASS,      D3DSTENCILOP_INCR);
	}
	else
	{
		pd3dDevice->SetRenderState(D3DRS_STENCILFUNC, D3DCMP_EQUAL);
		pd3dDevice->SetRenderState(D3DRS_STENCILPASS, D3DSTENCILOP_INCR);
		pd3dDevice->SetRenderState(D3DRS_STENCILREF,       0x1);
	}
	
		pd3dDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, true);
		pd3dDevice->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);
		pd3dDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);
	


  //   ,   z-
     //     
     //pd3dDevice->SetRenderState(D3DRS_ZENABLE, false);



	
	DrawObjects(pd3dDevice,Mode);
	

	
	 //pd3dDevice->SetRenderState(D3DRS_ZENABLE,          true);
     pd3dDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, false);

	 if (Mode==DO_SHADOW)   
	 {
		 pd3dDevice->SetRenderState(D3DRS_STENCILENABLE,    false);
		 pd3dDevice->Clear(0, 0, D3DCLEAR_STENCIL, 0, 1.0f, 0);

	 }
	 
	pd3dDevice->SetTransform(D3DTS_WORLD,&mWorld);
	

}


void CGeometry::DrawReflection(LPDIRECT3DDEVICE9 pd3dDevice)
{
	D3DXMATRIXA16 mWorld;
	pd3dDevice->GetTransform(D3DTS_WORLD,&mWorld);

	pd3dDevice->Clear(0, 0, D3DCLEAR_STENCIL, 0, 1.0f, 0);
	pd3dDevice->SetRenderState(D3DRS_STENCILENABLE,    true);
	pd3dDevice->SetRenderState(D3DRS_STENCILFUNC,      D3DCMP_ALWAYS);
	pd3dDevice->SetRenderState(D3DRS_STENCILREF,       0x1);
	pd3dDevice->SetRenderState(D3DRS_STENCILMASK,      0xffffffff);
	pd3dDevice->SetRenderState(D3DRS_STENCILWRITEMASK, 0xffffffff);
	pd3dDevice->SetRenderState(D3DRS_STENCILZFAIL,     D3DSTENCILOP_KEEP);
	pd3dDevice->SetRenderState(D3DRS_STENCILFAIL,      D3DSTENCILOP_KEEP);
	pd3dDevice->SetRenderState(D3DRS_STENCILPASS,      D3DSTENCILOP_REPLACE);

	//        
	pd3dDevice->SetRenderState(D3DRS_ZWRITEENABLE, false);

	//     
	pd3dDevice->SetMaterial(&MIRROR_MTRL);
	pd3dDevice->SetTexture(0, NULL);
	pd3dDevice->SetStreamSource( 0, g_pVB, 0, sizeof(CUSTOMVERTEX) );
	pd3dDevice->SetFVF( D3DFVF_CUSTOMVERTEX );
	pd3dDevice->SetIndices(g_pIB);
	pd3dDevice->DrawIndexedPrimitive(D3DPT_TRIANGLELIST , 0, 0, CountVertex, StartMirror, CountMirrorIndex/3 );

	//     
	pd3dDevice->SetRenderState(D3DRS_ZWRITEENABLE, true);


	//   ,     
	//    
	pd3dDevice->SetRenderState(D3DRS_STENCILFUNC, D3DCMP_EQUAL);
	pd3dDevice->SetRenderState(D3DRS_STENCILPASS, D3DSTENCILOP_KEEP);






	pd3dDevice->Clear(0, 0, D3DCLEAR_ZBUFFER, 0, 1.0f, 0);


	

	//pd3dDevice->SetTransform(D3DTS_WORLD, &W);
	pd3dDevice->SetRenderState(D3DRS_CULLMODE, D3DCULL_CW);
	DrawObjects(pd3dDevice,DO_MIRROR);
	DrawShadow(pd3dDevice,DO_MIRRORSHADOW);
	//    



	pd3dDevice->SetRenderState(D3DRS_STENCILENABLE,    false);
	pd3dDevice->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);

	pd3dDevice->SetStreamSource( 0, g_pVB, 0, sizeof(CUSTOMVERTEX) );

	//   ,    
	pd3dDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, true);
	pd3dDevice->SetRenderState(D3DRS_SRCBLEND,  D3DBLEND_DESTCOLOR);
	pd3dDevice->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_ZERO);
	pd3dDevice->SetMaterial(&MIRROR_MTRL);
	pd3dDevice->SetTexture(0, NULL);
	pd3dDevice->SetFVF( D3DFVF_CUSTOMVERTEX );
	pd3dDevice->SetIndices(g_pIB);
	pd3dDevice->DrawIndexedPrimitive(D3DPT_TRIANGLELIST , 0, 0, CountVertex, StartMirror, CountMirrorIndex/3 );

	pd3dDevice->SetRenderState(D3DRS_ALPHABLENDENABLE, false);

	pd3dDevice->SetTransform(D3DTS_WORLD,&mWorld);

}





HRESULT CGeometry::SetTexture(LPDIRECT3DDEVICE9 pd3dDevice,LPWSTR FileName)
{
	HRESULT hr;
	delete [] TextureFileName;
	TextureFileName=_wcsdup(FileName);
	SAFE_RELEASE(Tex);
	V_RETURN(D3DXCreateTextureFromFile(pd3dDevice,TextureFileName,&Tex));
	return S_OK;
}